<?php

namespace Bluesquare\Connect;

use Bluesquare\Connect\View\Components\Button;
use Illuminate\Support\ServiceProvider;

class ConnectServiceProvider extends ServiceProvider
{
    /**
     * Register any application services.
     *
     * @return void
     */
    public function register()
    {
        $this->mergeConfigFrom(
            __DIR__ . '/../config/bconnect.php',
            'bmail'
        );

        $this->app->singleton(Connect::class, function ($app) {
            return new Connect($app);
        });

        $this->loadViewsFrom(__DIR__.'/../resources/views/connect', 'connect');

        $this->publishes([
            __DIR__.'/../resources/views/connect' => resource_path('views/vendor/connect'),
        ]);

        $this->loadViewComponentsAs('connect', [
            Button::class
        ]);
    }

    /**
     * Bootstrap any application services.
     *
     * @return void
     */
    public function boot()
    {
        $this->publishes([
            __DIR__ . '/../config/bconnect.php' => config_path('bconnect.php')
        ], 'config');
    }
}
